#ifndef MAINWINDOW_H
#define MAINWINDOW_H


//#include "mysql.h"

#include "mymodel.h"
#include "settingform.h"
#include "delegate.h"
// #include "fileform.h"
#include "treedelegateform.h"

#include <QMainWindow>
#include <QStandardItemModel>
#include <QStandardItem>
#include <QTreeWidgetItem>
#include <QTextCodec>
#include <QSqlDatabase>

#include <QtGui>
#include <QString>
#include <QtSql>
#include <QFont>
#include <QColor>
#include <QItemDelegate>
#include <QList>
#include <QPalette>



/*
#include <QSqlField>
#include <QSqlRecord>
#include <QSqlTableModel>
#include <QSqlQueryModel>
#include <QTableView>
#include <QSqlDriverPlugin>
#include <QIcon>
#include <QVariant>
#include <QProcess>
#include <QByteArray>
*/

typedef struct Class {
        QString name;
        QString ID;

} TClass;




namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::MainWindow *ui;
    //FileForm fileForm;
    TreeDelegateForm treeForm;

        settingForm setFrm;
//    
        QString baseName;
        QString hostName;
        QString userName;
        QString password;
        QString tableName;

        void readSettings();
        void writeSettings();



    QList<QTreeWidgetItem *> root_items_list;
    QStandardItemModel *model;
    QStandardItem *item;
    QTreeWidgetItem *rootItem1, *rootItem2;
    void openBase();
    bool readModel();
    void setupModelData(const QStringList &lines, QTreeWidgetItem *parent, int row, QString model_id); // row -     ,   
    QString creatModelString(QTreeWidgetItem* model);
    QString modelString; // ,   
    void addChildsString(QTreeWidgetItem *parentItem, int level);

    QSqlDatabase sql;
    bool model_is_build; //  ,    (true)    (false)

    bool openDataBase();
    bool buildPreviewModel(QString modelName, QString rootClassID);

    bool rebuildPreviewModel(QTreeWidgetItem* root_item, QString rootClassID, int row);

    QString ClassName(QString class_id); //     ID
    void addChildsItems(QTreeWidgetItem *perent_class_item, int row); //          ,      
    QStringList classChields(QString class_id);
    QMap <QString, QString> getClassList(); //   
    QMap <QString, QString> getFieldsList(QString class_id); //    
    void initComboBox();
    QList<QTreeWidgetItem *> rootItems; //     ()

    /////// QSqlTableModel * sql_mogel;

    MyModel  * sql_mogel;
 ////   MyModel * filter_model;

    QSqlTableModel * filter_model;

    QSqlTableModel * model_for_ListModelsTable;

    void initListModelsTablle();
    void readModels(); //          

    int pointer_index; // -   
    QString parentObject_id;


    QMap <QString, QString> class_list_map;
    QMap <int, QTreeWidgetItem*> models_items; //   ( )       
    void getDatabaseData();
    void buildTree(QTreeWidgetItem * model_item);
    QString getClassInctance(QString class_id); //    -   
    void showClassObjects(QTreeWidgetItem * parent_item, QTreeWidgetItem * model_item); //   
    void showObjectChildrens(QString object_ID, QTreeWidgetItem * object_item, QTreeWidgetItem * model_item); //   
    void showObjects(QTreeWidgetItem * parent_object_item, QTreeWidgetItem * model_item, QString filtr);// //   
    QString getPointerFieldName(QString parent_class_id, QString chield_class_id); //   ,        

    QMap <QString, QString> getPointersList(QString class_id); //    -,      -
                                                                //      -   


    QMap <QString, QPixmap> getClassesIcons(); //     
                                                //     ID ,     -  


    QMap <QString, QPixmap> getObjectsIcon(QString inctance); //     
    //     ID ,     -  


    QStringList getDataFieldList(QString class_id); //     c  ""



    QStringList getBoolFieldList(QString class_id); //     c  "bool"


    QStringList getFileFieldList(QString class_id); //    ,    "


    QString getFiltrString(QString model_id, QString class_id); //  -     


    QList<TField> getFieldList(QString class_id);//    


    int getIconFieldIndex(QString inctance); //     


    void buildReport(bool advanced); //      OpenOffice,  advanced     
    // QTreeWidgetItem * model_item

    void getReport(QTreeWidgetItem * model_item, bool advanced); //       advanced     

    void printChild(QTreeWidgetItem * model_item, QString filtr, bool advanced, int pos);//    

    void newPage(int page_number);//    
    void newPage();//    

    SpinBoxDelegate spinDelegate;
    QItemDelegate standart_delegate;
    CPictureDelegate * picture_delegate;
    IconDelegate * iconDelegate;
    FileDelegate * fileDelegate; //     ,     
    FilterSpinBoxDelegate filterSpinDelegate;
    FilterConditionDelegate filterConditionDelegate, filterConditionDelegate_1, filterConditionDelegate_2;
    FilterValueDelegate filterValueDelegate; //     ,      

    bool comboBox_slot_enable; //   ,   item_index  ,   
    QList <int> boolFieldsIndexes_global; //      "BOOL"

    QMap <QString, QPixmap> classesIcons;

    QTextDocument doc;
    QTextCursor * cursor;



private slots:
    void on_comboBox_currentIndexChanged( int index );
    void on_treeWidget_itemChanged ( QTreeWidgetItem * item, int column );
    void on_treeWidget_itemClicked ( QTreeWidgetItem * item, int column );
    void on_treeWidget_2_itemClicked ( QTreeWidgetItem * item, int column );
    void on_pushButton_clicked(); //   " "
    void on_pushButton_2_clicked();//   "  "
    void on_pushButton_3_clicked();//   ""
    void on_pushButton_4_clicked();//   " "
    void on_pushButton_5_clicked();//   "  "
    void on_pushButton_6_clicked();//   "  "
    void on_pushButton_7_clicked();//   "" (  )
    void on_pushButton_8_clicked();//   "" (  )
    void on_pushButton_9_clicked();//   " " (  )
    void on_pushButton_10_clicked();//   " " (  )
    void on_pushButton_11_clicked();//   "" (  )
    void on_pushButton_12_clicked();//   " " (  )

    void on_sql_mogel_dataChanged ( const QModelIndex & topLeft, const QModelIndex & bottomRight ); //       
    void on_model_for_ListModelsTable_dataChanged ( const QModelIndex & topLeft, const QModelIndex & bottomRight ); //       
    void on_filter_model_dataChanged ( const QModelIndex & topLeft, const QModelIndex & bottomRight ); //       
    void applySetting();
    void getSetting(); //   
};




#endif // MAINWINDOW_H
